#ifndef _ADATA_FLASHRW_H
#define _ADATA_FLASHRW_H

/*
** flashrw.h - IOCTL handlers for reading and writing Flash memory on a card
*/

#include "device.h"
#include "ioctls.h"

extern OS_STATUS
ADMXRC_EraseFlash(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* req,
  ADMXRC_IOCTLS_ERASEFLASH* pIoctl,
  unsigned long inSize);

extern OS_STATUS
ADMXRC_GetFlashInfo(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* req,
  ADMXRC_IOCTLS_GETFLASHINFO* pIoctl,
  unsigned long outSize);

extern OS_STATUS
ADMXRC_GetFlashBlockInfo(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* req,
  ADMXRC_IOCTLS_GETFLASHBLOCKINFO* pIoctl,
  unsigned long inSize,
  unsigned long outSize);

extern OS_STATUS
ADMXRC_ReadFlash(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* req,
  ADMXRC_IOCTLS_READFLASH* pIoctl,
  unsigned long inSize);

extern OS_STATUS
ADMXRC_WriteFlash(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* req,
  ADMXRC_IOCTLS_WRITEFLASH* pIoctl,
  unsigned long inSize);

#endif
